/* Generated by wayland-scanner 1.22.0 */

#ifndef TEXT_INPUT_CROSTINI_UNSTABLE_V1_SERVER_PROTOCOL_H
#define TEXT_INPUT_CROSTINI_UNSTABLE_V1_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_text_input_crostini_unstable_v1 The text_input_crostini_unstable_v1 protocol
 * @section page_ifaces_text_input_crostini_unstable_v1 Interfaces
 * - @subpage page_iface_zcr_text_input_crostini_manager_v1 - factory for zcr_text_input_crostini_v1
 * - @subpage page_iface_zcr_text_input_crostini_v1 - Crostini extension support for text_input
 * @section page_copyright_text_input_crostini_unstable_v1 Copyright
 * <pre>
 *
 * Copyright 2023 The ChromiumOS Authors
 * Use of this source code is governed by a BSD-style license that can be
 * found in the LICENSE file.
 * </pre>
 */
struct wl_seat;
struct zcr_text_input_crostini_manager_v1;
struct zcr_text_input_crostini_v1;
struct zwp_text_input_v1;

#ifndef ZCR_TEXT_INPUT_CROSTINI_MANAGER_V1_INTERFACE
#define ZCR_TEXT_INPUT_CROSTINI_MANAGER_V1_INTERFACE
/**
 * @page page_iface_zcr_text_input_crostini_manager_v1 zcr_text_input_crostini_manager_v1
 * @section page_iface_zcr_text_input_crostini_manager_v1_desc Description
 *
 * @section page_iface_zcr_text_input_crostini_manager_v1_api API
 * See @ref iface_zcr_text_input_crostini_manager_v1.
 */
/**
 * @defgroup iface_zcr_text_input_crostini_manager_v1 The zcr_text_input_crostini_manager_v1 interface
 *
 */
extern const struct wl_interface zcr_text_input_crostini_manager_v1_interface;
#endif
#ifndef ZCR_TEXT_INPUT_CROSTINI_V1_INTERFACE
#define ZCR_TEXT_INPUT_CROSTINI_V1_INTERFACE
/**
 * @page page_iface_zcr_text_input_crostini_v1 zcr_text_input_crostini_v1
 * @section page_iface_zcr_text_input_crostini_v1_desc Description
 *
 * Adds extra text_input functionality specific to Crostini. This is only
 * used between sommelier and cros_im.
 * @section page_iface_zcr_text_input_crostini_v1_api API
 * See @ref iface_zcr_text_input_crostini_v1.
 */
/**
 * @defgroup iface_zcr_text_input_crostini_v1 The zcr_text_input_crostini_v1 interface
 *
 * Adds extra text_input functionality specific to Crostini. This is only
 * used between sommelier and cros_im.
 */
extern const struct wl_interface zcr_text_input_crostini_v1_interface;
#endif

#ifndef ZCR_TEXT_INPUT_CROSTINI_MANAGER_V1_ERROR_ENUM
#define ZCR_TEXT_INPUT_CROSTINI_MANAGER_V1_ERROR_ENUM
enum zcr_text_input_crostini_manager_v1_error {
	/**
	 * the text_input already has an text_input_crostini object associated
	 */
	ZCR_TEXT_INPUT_CROSTINI_MANAGER_V1_ERROR_TEXT_INPUT_CROSTINI_EXISTS = 0,
};
#endif /* ZCR_TEXT_INPUT_CROSTINI_MANAGER_V1_ERROR_ENUM */

/**
 * @ingroup iface_zcr_text_input_crostini_manager_v1
 * @struct zcr_text_input_crostini_manager_v1_interface
 */
struct zcr_text_input_crostini_manager_v1_interface {
	/**
	 * get zcr_text_input_crostini_v1 object
	 *
	 * Create a zcr_text_input_crostini_v1 object for a text_input.
	 * If an object has already been created, the
	 * text_input_crostini_exists protocol error is raised.
	 */
	void (*get_text_input_crostini)(struct wl_client *client,
					struct wl_resource *resource,
					uint32_t id,
					struct wl_resource *text_input);
};


/**
 * @ingroup iface_zcr_text_input_crostini_manager_v1
 */
#define ZCR_TEXT_INPUT_CROSTINI_MANAGER_V1_GET_TEXT_INPUT_CROSTINI_SINCE_VERSION 1

/**
 * @ingroup iface_zcr_text_input_crostini_v1
 * @struct zcr_text_input_crostini_v1_interface
 */
struct zcr_text_input_crostini_v1_interface {
	/**
	 * destroy zcr_text_input_crostini_v1 object
	 *
	 * 
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
	/**
	 * request activation
	 *
	 * Calls text_input::activate with the X11 window id converted to
	 * the matching wl_surface.
	 */
	void (*activate_x11)(struct wl_client *client,
			     struct wl_resource *resource,
			     struct wl_resource *seat,
			     uint32_t x11_window_id);
};


/**
 * @ingroup iface_zcr_text_input_crostini_v1
 */
#define ZCR_TEXT_INPUT_CROSTINI_V1_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_text_input_crostini_v1
 */
#define ZCR_TEXT_INPUT_CROSTINI_V1_ACTIVATE_X11_SINCE_VERSION 1

#ifdef  __cplusplus
}
#endif

#endif
