// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#ifndef VM_TOOLS_SOMMELIER_GEN_XDG_SHELL_SHIM_H_
#define VM_TOOLS_SOMMELIER_GEN_XDG_SHELL_SHIM_H_

#include "xdg-shell-client-protocol.h"  // NOLINT(build/include_directory)
#include "xdg-shell-server-protocol.h"  // NOLINT(build/include_directory)


class XdgWmBaseShim {
  public:
    XdgWmBaseShim() = default;
    XdgWmBaseShim(XdgWmBaseShim&&) = delete;
    XdgWmBaseShim& operator=(XdgWmBaseShim&&) = delete;
    virtual ~XdgWmBaseShim() = default;

    virtual void set_user_data(struct xdg_wm_base* xdg_wm_base, void* user_data);

    virtual void* get_user_data(struct xdg_wm_base* xdg_wm_base);
    virtual int add_listener(struct xdg_wm_base* xdg_wm_base, const struct xdg_wm_base_listener* listener, void* data);
    
    virtual void destroy(
        struct xdg_wm_base *xdg_wm_base);
    
    virtual struct xdg_positioner* create_positioner(
        struct xdg_wm_base *xdg_wm_base);
    
    virtual struct xdg_surface* get_xdg_surface(
        struct xdg_wm_base *xdg_wm_base,
        struct wl_surface* surface);
    
    virtual void pong(
        struct xdg_wm_base *xdg_wm_base,
        uint32_t serial);
    
    virtual void send_ping(
        struct wl_resource* resource,
        uint32_t serial);
    };

XdgWmBaseShim* xdg_wm_base_shim();
void set_xdg_wm_base_shim (XdgWmBaseShim* shim);

class XdgPositionerShim {
  public:
    XdgPositionerShim() = default;
    XdgPositionerShim(XdgPositionerShim&&) = delete;
    XdgPositionerShim& operator=(XdgPositionerShim&&) = delete;
    virtual ~XdgPositionerShim() = default;

    virtual void set_user_data(struct xdg_positioner* xdg_positioner, void* user_data);

    virtual void* get_user_data(struct xdg_positioner* xdg_positioner);
    virtual void destroy(
        struct xdg_positioner *xdg_positioner);
    
    virtual void set_size(
        struct xdg_positioner *xdg_positioner,
        int32_t width,
        int32_t height);
    
    virtual void set_anchor_rect(
        struct xdg_positioner *xdg_positioner,
        int32_t x,
        int32_t y,
        int32_t width,
        int32_t height);
    
    virtual void set_anchor(
        struct xdg_positioner *xdg_positioner,
        uint32_t anchor);
    
    virtual void set_gravity(
        struct xdg_positioner *xdg_positioner,
        uint32_t gravity);
    
    virtual void set_constraint_adjustment(
        struct xdg_positioner *xdg_positioner,
        uint32_t constraint_adjustment);
    
    virtual void set_offset(
        struct xdg_positioner *xdg_positioner,
        int32_t x,
        int32_t y);
    
    virtual void set_reactive(
        struct xdg_positioner *xdg_positioner);
    
    virtual void set_parent_size(
        struct xdg_positioner *xdg_positioner,
        int32_t parent_width,
        int32_t parent_height);
    
    virtual void set_parent_configure(
        struct xdg_positioner *xdg_positioner,
        uint32_t serial);
    };

XdgPositionerShim* xdg_positioner_shim();
void set_xdg_positioner_shim (XdgPositionerShim* shim);

class XdgSurfaceShim {
  public:
    XdgSurfaceShim() = default;
    XdgSurfaceShim(XdgSurfaceShim&&) = delete;
    XdgSurfaceShim& operator=(XdgSurfaceShim&&) = delete;
    virtual ~XdgSurfaceShim() = default;

    virtual void set_user_data(struct xdg_surface* xdg_surface, void* user_data);

    virtual void* get_user_data(struct xdg_surface* xdg_surface);
    virtual int add_listener(struct xdg_surface* xdg_surface, const struct xdg_surface_listener* listener, void* data);
    
    virtual void destroy(
        struct xdg_surface *xdg_surface);
    
    virtual struct xdg_toplevel* get_toplevel(
        struct xdg_surface *xdg_surface);
    
    virtual struct xdg_popup* get_popup(
        struct xdg_surface *xdg_surface,
        struct xdg_surface* parent,
        struct xdg_positioner* positioner);
    
    virtual void set_window_geometry(
        struct xdg_surface *xdg_surface,
        int32_t x,
        int32_t y,
        int32_t width,
        int32_t height);
    
    virtual void ack_configure(
        struct xdg_surface *xdg_surface,
        uint32_t serial);
    
    virtual void send_configure(
        struct wl_resource* resource,
        uint32_t serial);
    };

XdgSurfaceShim* xdg_surface_shim();
void set_xdg_surface_shim (XdgSurfaceShim* shim);

class XdgToplevelShim {
  public:
    XdgToplevelShim() = default;
    XdgToplevelShim(XdgToplevelShim&&) = delete;
    XdgToplevelShim& operator=(XdgToplevelShim&&) = delete;
    virtual ~XdgToplevelShim() = default;

    virtual void set_user_data(struct xdg_toplevel* xdg_toplevel, void* user_data);

    virtual void* get_user_data(struct xdg_toplevel* xdg_toplevel);
    virtual int add_listener(struct xdg_toplevel* xdg_toplevel, const struct xdg_toplevel_listener* listener, void* data);
    
    virtual void destroy(
        struct xdg_toplevel *xdg_toplevel);
    
    virtual void set_parent(
        struct xdg_toplevel *xdg_toplevel,
        struct xdg_toplevel* parent);
    
    virtual void set_title(
        struct xdg_toplevel *xdg_toplevel,
        const char * title);
    
    virtual void set_app_id(
        struct xdg_toplevel *xdg_toplevel,
        const char * app_id);
    
    virtual void show_window_menu(
        struct xdg_toplevel *xdg_toplevel,
        struct wl_seat* seat,
        uint32_t serial,
        int32_t x,
        int32_t y);
    
    virtual void move(
        struct xdg_toplevel *xdg_toplevel,
        struct wl_seat* seat,
        uint32_t serial);
    
    virtual void resize(
        struct xdg_toplevel *xdg_toplevel,
        struct wl_seat* seat,
        uint32_t serial,
        uint32_t edges);
    
    virtual void set_max_size(
        struct xdg_toplevel *xdg_toplevel,
        int32_t width,
        int32_t height);
    
    virtual void set_min_size(
        struct xdg_toplevel *xdg_toplevel,
        int32_t width,
        int32_t height);
    
    virtual void set_maximized(
        struct xdg_toplevel *xdg_toplevel);
    
    virtual void unset_maximized(
        struct xdg_toplevel *xdg_toplevel);
    
    virtual void set_fullscreen(
        struct xdg_toplevel *xdg_toplevel,
        struct wl_output* output);
    
    virtual void unset_fullscreen(
        struct xdg_toplevel *xdg_toplevel);
    
    virtual void set_minimized(
        struct xdg_toplevel *xdg_toplevel);
    
    virtual void send_configure(
        struct wl_resource* resource,
        int32_t width,
        int32_t height,
        struct wl_array* states);
    
    virtual void send_close(
        struct wl_resource* resource);
    };

XdgToplevelShim* xdg_toplevel_shim();
void set_xdg_toplevel_shim (XdgToplevelShim* shim);

class XdgPopupShim {
  public:
    XdgPopupShim() = default;
    XdgPopupShim(XdgPopupShim&&) = delete;
    XdgPopupShim& operator=(XdgPopupShim&&) = delete;
    virtual ~XdgPopupShim() = default;

    virtual void set_user_data(struct xdg_popup* xdg_popup, void* user_data);

    virtual void* get_user_data(struct xdg_popup* xdg_popup);
    virtual int add_listener(struct xdg_popup* xdg_popup, const struct xdg_popup_listener* listener, void* data);
    
    virtual void destroy(
        struct xdg_popup *xdg_popup);
    
    virtual void grab(
        struct xdg_popup *xdg_popup,
        struct wl_seat* seat,
        uint32_t serial);
    
    virtual void reposition(
        struct xdg_popup *xdg_popup,
        struct xdg_positioner* positioner,
        uint32_t token);
    
    virtual void send_configure(
        struct wl_resource* resource,
        int32_t x,
        int32_t y,
        int32_t width,
        int32_t height);
    
    virtual void send_popup_done(
        struct wl_resource* resource);
    
    virtual void send_repositioned(
        struct wl_resource* resource,
        uint32_t token);
    };

XdgPopupShim* xdg_popup_shim();
void set_xdg_popup_shim (XdgPopupShim* shim);

 
#endif // VM_TOOLS_SOMMELIER_GEN_XDG_SHELL_SHIM_H_